import java.util.Scanner;

public class Main {
	public static void main(String[] args) {
		Scanner s = new Scanner(System.in);
		int i = 0;
		int j;
		int N = s.nextInt();
		String mogucnost = "moguce";
		String [] pacijenti = new String[N];
		int [] brojDoza = new int[N];
		int O = s.nextInt();
		int A = s.nextInt();
		int B = s.nextInt();
		int AB = s.nextInt();
		/*for(int i=0;i>N;i++){
			pacijenti[i] = s.next();
			brojDoza[i] = s.nextInt();
		}*/
		while(N != 0) {
			pacijenti[i] = s.next();
			brojDoza[i] = s.nextInt();
			if (pacijenti[i].equalsIgnoreCase("o")) {
				if (O >= brojDoza[i]) {
					O = O - brojDoza[i]; 
				}else {
					mogucnost = "nemoguce";
				}
				
				
			}else if(pacijenti[i].equalsIgnoreCase("A")){
				if(A + O >=brojDoza[i]) {
					if(A >= brojDoza[i]) {
						A = A - brojDoza[i];
					}else {
						if ( A<O) {
							brojDoza[i] = brojDoza[i] - A;
							O = O - brojDoza[i];
						}else {
							brojDoza[i] = brojDoza[i] - O;
							A = A - brojDoza[i];
						}
					
					}
				}else {
					mogucnost = "nemoguce";
				}
			}else if(pacijenti[i].equalsIgnoreCase("B")){
				if(B + O >=brojDoza[i]) {
					if(B >= brojDoza[i]) {
						B = B - brojDoza[i];
					}else {
						if ( B<O) {
							brojDoza[i] = brojDoza[i] - B;
							O = O - brojDoza[i];
						}else {
							brojDoza[i] = brojDoza[i] - O;
							B = B - brojDoza[i];
						}
					}
					
				}else {
					mogucnost = "nemoguce";
				}
			}else if(pacijenti[i].equalsIgnoreCase("AB")) {
				if(A + B + O + AB>= brojDoza[i]) {
					if(AB >= brojDoza[i]) {
						AB = AB - brojDoza[i];
					}else if(A + B+ O >= brojDoza[i]) {
						if(A >= brojDoza[i]) {
							A = A - brojDoza[i];
						}else if(B + O >= brojDoza[i]){
							if ( B<O) {
								brojDoza[i] = brojDoza[i] - B;
								O = O - brojDoza[i];
							}else {
								brojDoza[i] = brojDoza[i] - O;
								B = B - brojDoza[i];
							}
							
						}
						
					}
				}else {
					mogucnost = "nemoguce";
				}
				
			}else {
				System.out.println("Pogrešan ulaz!");
				mogucnost = " ";
			}
			i++;
			N--;
		}
	
		
		System.out.println(mogucnost);
	}
}